diff --git a/toolkit/crashreporter/google-breakpad/src/common/linux/dump_symbols.h b/toolkit/crashreporter/google-breakpad/src/common/linux/dump_symbols.h
--- a/toolkit/crashreporter/google-breakpad/src/common/linux/dump_symbols.h
+++ b/toolkit/crashreporter/google-breakpad/src/common/linux/dump_symbols.h
@@ -36,14 +36,14 @@
 #include <string>
 #include <cstdio>
 
 namespace google_breakpad {
 
 class DumpSymbols {
  public:
   bool WriteSymbolFile(const std::string &obj_file,
-                       int sym_fd);
+                       FILE *sym_file);
 };
 
 }  // namespace google_breakpad
 
 #endif  // COMMON_LINUX_DUMP_SYMBOLS_H__
diff --git a/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.cc b/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.cc
--- a/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.cc
+++ b/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.cc
@@ -27,114 +27,148 @@
 // (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 // OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 //
 // file_id.cc: Return a unique identifier for a file
 //
 // See file_id.h for documentation
 //
 
-#include <cassert>
-#include <cstdio>
+#include "common/linux/file_id.h"
+#include "common/linux/linux_libc_support.h"
+#include "common/linux/linux_syscall_support.h"
+
+#include <arpa/inet.h>
 #include <elf.h>
 #include <fcntl.h>
 #include <link.h>
+#include <string.h>
 #include <sys/mman.h>
-#include <string.h>
 #include <unistd.h>
 
-#include "common/linux/file_id.h"
-#include "common/md5.h"
+#include <algorithm>
+#include <cassert>
+#include <cstdio>
 
 namespace google_breakpad {
 
-static bool FindElfTextSection(const void *elf_mapped_base,
-                               const void **text_start,
-                               int *text_size) {
+FileID::FileID(const char* path) {
+  strncpy(path_, path, sizeof(path_));
+}
+
+// These two functions are also used inside the crashed process, so be safe
+// and use the syscall/libc wrappers instead of direct syscalls or libc.
+  static bool FindElfTextSection(const void *elf_mapped_base,
+                                 const void **text_start,
+                                 int *text_size) {
   assert(elf_mapped_base);
   assert(text_start);
   assert(text_size);
 
-  const unsigned char *elf_base =
-    static_cast<const unsigned char *>(elf_mapped_base);
-  const ElfW(Ehdr) *elf_header =
-    reinterpret_cast<const ElfW(Ehdr) *>(elf_base);
-  if (memcmp(elf_header, ELFMAG, SELFMAG) != 0)
+  const char* elf_base =
+    static_cast<const char*>(elf_mapped_base);
+  const ElfW(Ehdr)* elf_header =
+    reinterpret_cast<const ElfW(Ehdr)*>(elf_base);
+  if (my_strncmp(elf_base, ELFMAG, SELFMAG) != 0)
+    return false;
+#if __ELF_NATIVE_CLASS == 32
+#define ELFCLASS ELFCLASS32
+#else
+#define ELFCLASS ELFCLASS64
+#endif
+  //TODO: support dumping 32-bit binaries from a 64-bit dump_syms?
+  if (elf_header->e_ident[EI_CLASS] != ELFCLASS)
     return false;
   *text_start = NULL;
   *text_size = 0;
-  const ElfW(Shdr) *sections =
-    reinterpret_cast<const ElfW(Shdr) *>(elf_base + elf_header->e_shoff);
-  const char *text_section_name = ".text";
-  int name_len = strlen(text_section_name);
-  const ElfW(Shdr) *string_section = sections + elf_header->e_shstrndx;
-  const ElfW(Shdr) *text_section = NULL;
+  const ElfW(Shdr)* sections =
+    reinterpret_cast<const ElfW(Shdr)*>(elf_base + elf_header->e_shoff);
+  const char* text_section_name = ".text";
+  int name_len = my_strlen(text_section_name);
+  const ElfW(Shdr)* string_section = sections + elf_header->e_shstrndx;
+  const ElfW(Shdr)* text_section = NULL;
   for (int i = 0; i < elf_header->e_shnum; ++i) {
     if (sections[i].sh_type == SHT_PROGBITS) {
-      const char *section_name = (char*)(elf_base +
+      const char* section_name = (char*)(elf_base +
                                          string_section->sh_offset +
                                          sections[i].sh_name);
-      if (!strncmp(section_name, text_section_name, name_len)) {
+      if (!my_strncmp(section_name, text_section_name, name_len)) {
         text_section = &sections[i];
         break;
       }
     }
   }
   if (text_section != NULL && text_section->sh_size > 0) {
-    int text_section_size = text_section->sh_size;
     *text_start = elf_base + text_section->sh_offset;
-    *text_size = text_section_size;
+    *text_size = text_section->sh_size;
   }
   return true;
 }
 
-FileID::FileID(const char *path) {
-  strncpy(path_, path, sizeof(path_));
+// static
+bool FileID::ElfFileIdentifierFromMappedFile(void* base,
+                                             uint8_t identifier[kMDGUIDSize])
+{
+  const void* text_section = NULL;
+  int text_size = 0;
+  bool success = false;
+  if (FindElfTextSection(base, &text_section, &text_size) && (text_size > 0)) {
+    my_memset(identifier, 0, kMDGUIDSize);
+    const uint8_t* ptr = reinterpret_cast<const uint8_t*>(text_section);
+    const uint8_t* ptr_end = ptr + std::min(text_size, 4096);
+    while (ptr < ptr_end) {
+      for (unsigned i = 0; i < kMDGUIDSize; i++)
+        identifier[i] ^= ptr[i];
+      ptr += kMDGUIDSize;
+    }
+    success = true;
+  }
+  return success;
 }
 
-bool FileID::ElfFileIdentifier(unsigned char identifier[16]) {
+bool FileID::ElfFileIdentifier(uint8_t identifier[kMDGUIDSize]) {
   int fd = open(path_, O_RDONLY);
   if (fd < 0)
     return false;
   struct stat st;
-  if (fstat(fd, &st) != 0 && st.st_size <= 0) {
+  if (fstat(fd, &st) != 0) {
     close(fd);
     return false;
   }
-  void *base = mmap(NULL, st.st_size,
+  void* base = mmap(NULL, st.st_size,
                     PROT_READ | PROT_WRITE, MAP_PRIVATE, fd, 0);
-  if (!base) {
-    close(fd);
+  close(fd);
+  if (base == MAP_FAILED)
     return false;
-  }
-  bool success = false;
-  const void *text_section = NULL;
-  int text_size = 0;
-  if (FindElfTextSection(base, &text_section, &text_size) && (text_size > 0)) {
-    struct MD5Context md5;
-    MD5Init(&md5);
-    MD5Update(&md5,
-              static_cast<const unsigned char*>(text_section),
-              text_size);
-    MD5Final(identifier, &md5);
-    success = true;
-  }
 
-  close(fd);
+  bool success = ElfFileIdentifierFromMappedFile(base, identifier);
   munmap(base, st.st_size);
   return success;
 }
 
 // static
-void FileID::ConvertIdentifierToString(const unsigned char identifier[16],
-                                       char *buffer, int buffer_length) {
+void FileID::ConvertIdentifierToString(const uint8_t identifier[kMDGUIDSize],
+                                       char* buffer, int buffer_length) {
+  uint8_t identifier_swapped[kMDGUIDSize];
+
+  // Endian-ness swap to match dump processor expectation.
+  memcpy(identifier_swapped, identifier, kMDGUIDSize);
+  uint32_t* data1 = reinterpret_cast<uint32_t*>(identifier_swapped);
+  *data1 = htonl(*data1);
+  uint16_t* data2 = reinterpret_cast<uint16_t*>(identifier_swapped + 4);
+  *data2 = htons(*data2);
+  uint16_t* data3 = reinterpret_cast<uint16_t*>(identifier_swapped + 6);
+  *data3 = htons(*data3);
+
   int buffer_idx = 0;
-  for (int idx = 0; (buffer_idx < buffer_length) && (idx < 16); ++idx) {
-    int hi = (identifier[idx] >> 4) & 0x0F;
-    int lo = (identifier[idx]) & 0x0F;
+  for (unsigned int idx = 0;
+       (buffer_idx < buffer_length) && (idx < kMDGUIDSize);
+       ++idx) {
+    int hi = (identifier_swapped[idx] >> 4) & 0x0F;
+    int lo = (identifier_swapped[idx]) & 0x0F;
 
     if (idx == 4 || idx == 6 || idx == 8 || idx == 10)
       buffer[buffer_idx++] = '-';
 
     buffer[buffer_idx++] = (hi >= 10) ? 'A' + hi - 10 : '0' + hi;
     buffer[buffer_idx++] = (lo >= 10) ? 'A' + lo - 10 : '0' + lo;
   }
 
diff --git a/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.h b/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.h
--- a/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.h
+++ b/toolkit/crashreporter/google-breakpad/src/common/linux/file_id.h
@@ -30,37 +30,47 @@
 // file_id.h: Return a unique identifier for a file
 //
 
 #ifndef COMMON_LINUX_FILE_ID_H__
 #define COMMON_LINUX_FILE_ID_H__
 
 #include <limits.h>
 
+#include "common/linux/guid_creator.h"
+
 namespace google_breakpad {
 
+static const size_t kMDGUIDSize = sizeof(MDGUID);
+
 class FileID {
  public:
-  FileID(const char *path);
-  ~FileID() {};
+  explicit FileID(const char* path);
+  ~FileID() {}
 
   // Load the identifier for the elf file path specified in the constructor into
   // |identifier|.  Return false if the identifier could not be created for the
   // file.
-  // The current implementation will return the MD5 hash of the file's bytes.
-  bool ElfFileIdentifier(unsigned char identifier[16]);
+  // The current implementation will XOR the first 4096 bytes of the
+  // .text section to generate an identifier.
+  bool ElfFileIdentifier(uint8_t identifier[kMDGUIDSize]);
+
+  // Load the identifier for the elf file mapped into memory at |base| into
+  // |identifier|.  Return false if the identifier could not be created for the
+  // file.
+  static bool ElfFileIdentifierFromMappedFile(void* base,
+                                              uint8_t identifier[kMDGUIDSize]);
 
   // Convert the |identifier| data to a NULL terminated string.  The string will
   // be formatted as a UUID (e.g., 22F065BB-FC9C-49F7-80FE-26A7CEBD7BCE).
   // The |buffer| should be at least 37 bytes long to receive all of the data
   // and termination.  Shorter buffers will contain truncated data.
-  static void ConvertIdentifierToString(const unsigned char identifier[16],
-                                        char *buffer, int buffer_length);
+  static void ConvertIdentifierToString(const uint8_t identifier[kMDGUIDSize],
+                                        char* buffer, int buffer_length);
 
  private:
   // Storage for the path specified
   char path_[PATH_MAX];
 };
 
 }  // namespace google_breakpad
 
 #endif  // COMMON_LINUX_FILE_ID_H__
-
diff --git a/toolkit/crashreporter/google-breakpad/src/common/linux/file_id_unittest.cc b/toolkit/crashreporter/google-breakpad/src/common/linux/file_id_unittest.cc
new file mode 100644
--- /dev/null
+++ b/toolkit/crashreporter/google-breakpad/src/common/linux/file_id_unittest.cc
@@ -0,0 +1,76 @@
+// Copyright (c) 2009, Google Inc.
+// All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+//
+//     * Redistributions of source code must retain the above copyright
+// notice, this list of conditions and the following disclaimer.
+//     * Redistributions in binary form must reproduce the above
+// copyright notice, this list of conditions and the following disclaimer
+// in the documentation and/or other materials provided with the
+// distribution.
+//     * Neither the name of Google Inc. nor the names of its
+// contributors may be used to endorse or promote products derived from
+// this software without specific prior written permission.
+//
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+// Unit tests for FileID
+
+#include <stdlib.h>
+
+#include "common/linux/file_id.h"
+#include "breakpad_googletest_includes.h"
+
+using namespace google_breakpad;
+
+
+namespace {
+typedef testing::Test FileIDTest;
+}
+
+TEST(FileIDTest, FileIDStrip) {
+  // Calculate the File ID of our binary using
+  // FileID::ElfFileIdentifier, then make a copy of our binary,
+  // strip it, and ensure that we still get the same result.
+  char exe_name[PATH_MAX];
+  ssize_t len = readlink("/proc/self/exe", exe_name, PATH_MAX - 1);
+  ASSERT_NE(len, -1);
+  exe_name[len] = '\0';
+
+  // copy our binary to a temp file, and strip it
+  char templ[] = "/tmp/file-id-unittest-XXXXXX";
+  mktemp(templ);
+  char cmdline[4096];
+  sprintf(cmdline, "cp \"%s\" \"%s\"", exe_name, templ);
+  ASSERT_EQ(system(cmdline), 0);
+  sprintf(cmdline, "strip \"%s\"", templ);
+  ASSERT_EQ(system(cmdline), 0);
+
+  uint8_t identifier1[sizeof(MDGUID)];
+  uint8_t identifier2[sizeof(MDGUID)];
+  FileID fileid1(exe_name);
+  EXPECT_TRUE(fileid1.ElfFileIdentifier(identifier1));
+  FileID fileid2(templ);
+  EXPECT_TRUE(fileid2.ElfFileIdentifier(identifier2));
+  char identifier_string1[37];
+  char identifier_string2[37];
+  FileID::ConvertIdentifierToString(identifier1, identifier_string1,
+                                    37);
+  FileID::ConvertIdentifierToString(identifier2, identifier_string2,
+                                    37);
+  EXPECT_STREQ(identifier_string1, identifier_string2);
+  unlink(templ);
+}
diff --git a/toolkit/crashreporter/google-breakpad/src/common/linux/google_crashdump_uploader.cc b/toolkit/crashreporter/google-breakpad/src/common/linux/google_crashdump_uploader.cc
new file mode 100644
--- /dev/null
+++ b/toolkit/crashreporter/google-breakpad/src/common/linux/google_crashdump_uploader.cc
@@ -0,0 +1,196 @@
+// Copyright (c) 2009, Google Inc.
+// All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+//
+//     * Redistributions of source code must retain the above copyright
+// notice, this list of conditions and the following disclaimer.
+//     * Redistributions in binary form must reproduce the above
+// copyright notice, this list of conditions and the following disclaimer
+// in the documentation and/or other materials provided with the
+// distribution.
+//     * Neither the name of Google Inc. nor the names of its
+// contributors may be used to endorse or promote products derived from
+// this software without specific prior written permission.
+//
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+#include "common/linux/google_crashdump_uploader.h"
+#include "common/linux/libcurl_wrapper.h"
+#include "third_party/linux/include/glog/logging.h"
+
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+namespace google_breakpad {
+
+GoogleCrashdumpUploader::GoogleCrashdumpUploader(const std::string& product,
+                                                 const std::string& version,
+                                                 const std::string& guid,
+                                                 const std::string& ptime,
+                                                 const std::string& ctime,
+                                                 const std::string& email,
+                                                 const std::string& comments,
+                                                 const std::string& minidump_pathname,
+                                                 const std::string& crash_server,
+                                                 const std::string& proxy_host,
+                                                 const std::string& proxy_userpassword) {
+  LibcurlWrapper* http_layer = new LibcurlWrapper();
+  Init(product,
+       version,
+       guid,
+       ptime,
+       ctime,
+       email,
+       comments,
+       minidump_pathname,
+       crash_server,
+       proxy_host,
+       proxy_userpassword,
+       http_layer);
+}
+
+GoogleCrashdumpUploader::GoogleCrashdumpUploader(const std::string& product,
+                                                 const std::string& version,
+                                                 const std::string& guid,
+                                                 const std::string& ptime,
+                                                 const std::string& ctime,
+                                                 const std::string& email,
+                                                 const std::string& comments,
+                                                 const std::string& minidump_pathname,
+                                                 const std::string& crash_server,
+                                                 const std::string& proxy_host,
+                                                 const std::string& proxy_userpassword,
+                                                 LibcurlWrapper* http_layer) {
+  Init(product,
+       version,
+       guid,
+       ptime,
+       ctime,
+       email,
+       comments,
+       minidump_pathname,
+       crash_server,
+       proxy_host,
+       proxy_userpassword,
+       http_layer);
+}
+
+void GoogleCrashdumpUploader::Init(const std::string& product,
+                                   const std::string& version,
+                                   const std::string& guid,
+                                   const std::string& ptime,
+                                   const std::string& ctime,
+                                   const std::string& email,
+                                   const std::string& comments,
+                                   const std::string& minidump_pathname,
+                                   const std::string& crash_server,
+                                   const std::string& proxy_host,
+                                   const std::string& proxy_userpassword,
+                                   LibcurlWrapper* http_layer) {
+  product_ = product;
+  version_ = version;
+  guid_ = guid;
+  ptime_ = ptime;
+  ctime_ = ctime;
+  email_ = email;
+  comments_ = comments;
+  http_layer_ = http_layer;
+
+  crash_server_ = crash_server;
+  proxy_host_ = proxy_host;
+  proxy_userpassword_ = proxy_userpassword;
+  minidump_pathname_ = minidump_pathname;
+  LOG(INFO) << "Uploader initializing";
+  LOG(INFO) << "\tProduct: " << product_;
+  LOG(INFO) << "\tVersion: " << version_;
+  LOG(INFO) << "\tGUID: " << guid_;
+  if (!ptime_.empty()) {
+    LOG(INFO) << "\tProcess uptime: " << ptime_;
+  }
+  if (!ctime_.empty()) {
+    LOG(INFO) << "\tCumulative Process uptime: " << ctime_;
+  }
+  if (!email_.empty()) {
+    LOG(INFO) << "\tEmail: " << email_;
+  }
+  if (!comments_.empty()) {
+    LOG(INFO) << "\tComments: " << comments_;
+  }
+}
+
+bool GoogleCrashdumpUploader::CheckRequiredParametersArePresent() {
+  std::string error_text;
+  if (product_.empty()) {
+    error_text.append("\nProduct name must be specified.");
+  }
+
+  if (version_.empty()) {
+    error_text.append("\nProduct version must be specified.");
+  }
+
+  if (guid_.empty()) {
+    error_text.append("\nClient ID must be specified.");
+  }
+
+  if (minidump_pathname_.empty()) {
+    error_text.append("\nMinidump pathname must be specified.");
+  }
+
+  if (!error_text.empty()) {
+    LOG(ERROR) << error_text;
+    return false;
+  }
+  return true;
+
+}
+
+bool GoogleCrashdumpUploader::Upload() {
+  bool ok = http_layer_->Init();
+  if (!ok) {
+    LOG(WARNING) << "http layer init failed";
+    return ok;
+  }
+
+  if (!CheckRequiredParametersArePresent()) {
+    return false;
+  }
+
+  struct stat st;
+  int err = stat(minidump_pathname_.c_str(), &st);
+  if (err) {
+    LOG(WARNING) << minidump_pathname_ << " could not be found: " << errno;
+    return false;
+  }
+
+  parameters_["prod"] = product_;
+  parameters_["ver"] = version_;
+  parameters_["guid"] = guid_;
+  parameters_["ptime"] = ptime_;
+  parameters_["ctime"] = ctime_;
+  parameters_["email"] = email_;
+  parameters_["comments_"] = comments_;
+  if (!http_layer_->AddFile(minidump_pathname_,
+                            "upload_file_minidump")) {
+    return false;
+  }
+  LOG(INFO) << "Sending request to " << crash_server_;
+  return http_layer_->SendRequest(crash_server_,
+                                  parameters_,
+                                  NULL);
+}
+}
diff --git a/toolkit/crashreporter/google-breakpad/src/common/linux/google_crashdump_uploader.h b/toolkit/crashreporter/google-breakpad/src/common/linux/google_crashdump_uploader.h
new file mode 100644
--- /dev/null
+++ b/toolkit/crashreporter/google-breakpad/src/common/linux/google_crashdump_uploader.h
@@ -0,0 +1,98 @@
+// Copyright (c) 2009, Google Inc.
+// All rights reserved.
+//
+// Redistribution and use in source and binary forms, with or without
+// modification, are permitted provided that the following conditions are
+// met:
+//
+//     * Redistributions of source code must retain the above copyright
+// notice, this list of conditions and the following disclaimer.
+//     * Redistributions in binary form must reproduce the above
+// copyright notice, this list of conditions and the following disclaimer
+// in the documentation and/or other materials provided with the
+// distribution.
+//     * Neither the name of Google Inc. nor the names of its
+// contributors may be used to endorse or promote products derived from
+// this software without specific prior written permission.
+//
+// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
+// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
+// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
+// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
+// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
+// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+
+#include <string>
+#include <map>
+
+namespace google_breakpad {
+
+class LibcurlWrapper;
+
+class GoogleCrashdumpUploader {
+ public:
+  GoogleCrashdumpUploader(const std::string& product,
+                          const std::string& version,
+                          const std::string& guid,
+                          const std::string& ptime,
+                          const std::string& ctime,
+                          const std::string& email,
+                          const std::string& comments,
+                          const std::string& minidump_pathname,
+                          const std::string& crash_server,
+                          const std::string& proxy_host,
+                          const std::string& proxy_userpassword);
+
+  GoogleCrashdumpUploader(const std::string& product,
+                          const std::string& version,
+                          const std::string& guid,
+                          const std::string& ptime,
+                          const std::string& ctime,
+                          const std::string& email,
+                          const std::string& comments,
+                          const std::string& minidump_pathname,
+                          const std::string& crash_server,
+                          const std::string& proxy_host,
+                          const std::string& proxy_userpassword,
+                          LibcurlWrapper* http_layer);
+
+  void Init(const std::string& product,
+            const std::string& version,
+            const std::string& guid,
+            const std::string& ptime,
+            const std::string& ctime,
+            const std::string& email,
+            const std::string& comments,
+            const std::string& minidump_pathname,
+            const std::string& crash_server,
+            const std::string& proxy_host,
+            const std::string& proxy_userpassword,
+            LibcurlWrapper* http_layer);
+  bool Upload();
+
+ private:
+  bool CheckRequiredParametersArePresent();
+
+  LibcurlWrapper* http_layer_;
+  std::string product_;
+  std::string version_;
+  std::string guid_;
+  std::string ptime_;
+  std::string ctime_;
+  std::string email_;
+  std::string comments_;
+  std::string minidump_pathname_;
+
+  std::string crash_server_;
+  std::string proxy_host_;
+  std::string proxy_userpassword_;
+
+  std::map<std::string, std::string> parameters_;
+};
+}
